
;chicken-install invokes as "<csi> -s run.scm <eggnam> <eggdir>"

(define *egg-name* "message-digest")

(use files)

;no -disable-interrupts
(define *csc-options* "-inline-global -scrutinize -optimize-leaf-routines -local -inline -specialize -unsafe -no-trace -no-lambda-info -clustering -lfa2")

(define *args* (argv))

(define (test-name #!optional (eggnam *egg-name*))
  (string-append eggnam "-test") )

(define (egg-name #!optional (def *egg-name*))
  (cond
    ((<= 4 (length *args*))
      (cadddr *args*) )
    (def
      def )
    (else
      (error 'test "cannot determine egg-name") ) ) )

;;;

(set! *egg-name* (egg-name))

(define (run-test #!optional (eggnam *egg-name*) (cscopts *csc-options*))
  (let ((tstnam (test-name eggnam)))
    (print "*** csi ***")
    (system (string-append "csi -s " (make-pathname #f tstnam "scm")))
    (newline)
    (print "*** csc (" cscopts ") ***")
    (system (string-append "csc" " " cscopts " " (make-pathname #f tstnam "scm")))
    (system (make-pathname (cond-expand (unix "./") (else #f)) tstnam)) ) )

;;;

(run-test)
